// Convolution_FFT.c    RAMP tB^  gԂł̃R{[V

#include "HU.h" 

void FFT1D( double x[] , double y[] , int data_n , int invert )
{
	// Numerical Recipes in C (p390-391) p (ꕔύX)B
	
	// invert  1 Ȃ΁A摜 x Pt[Gϊ
	// ʂ  x ,  y ̔zɓB
	// data_n ́Af[^iQ̊K̕KvjB

	// invert  -1 Ȃ΁A x ,  y 
	// Ptt[GϊāAʂ x ̔zɓB
	
	int		i,j,m,n,mmax,istep;
	double	tempi,tempr,temp;
	double	theta,wi,wpi,wpr,wr,wtemp, PI = 3.141592653589793; 
	double	*data;

	data = calloc( (data_n + 1) * 2, sizeof(double) );

	for (i=1; i<=data_n  ; i++ ){
	
		data[2*i-1]=x[i];   data[2*i]=y[i];
	}

		n = data_n << 1;
		j = 1;

		for(i = 1; i < n ; i+=2 ){
		
			if(j > i){
			
				temp=data[j];   data[j]  =data[i];   data[i]  =temp;                
				temp=data[j+1]; data[j+1]=data[i+1]; data[i+1]=temp;
			}
			m = n >> 1;
		
			while( m >= 2 && j > m ){
			
				j -= m;
				m >>= 1;
			}
			
			j += m;
		}
	
		// Danielson-Lanczos  FFT ASY
		
		mmax = 2;
		
		while( n > mmax ){
		
			istep = mmax << 1;
			theta = invert * 2.0 * PI / mmax ; 
			wtemp = sin(0.5*theta);
			wpr = -2.0 * wtemp * wtemp;
			wpi = sin(theta);
			wr = 1.0; wi = 0.0;

			for( m = 1; m < mmax; m+=2 ){

				for( i = m; i <= n; i+=istep ){
					
					j = i + mmax;
					tempr     = wr*data[j] - wi*data[j+1];
					tempi     = wr*data[j+1] + wi*data[j];
					data[j]   = data[i]-tempr;
					data[j+1] = data[i+1]-tempi;
					data[i]  += tempr;
					data[i+1]+= tempi;
				}
								
				wr = (wtemp=wr)*wpr - wi*wpi + wr;
				wi = wi*wpr + wtemp*wpi + wi;
			}
			
			mmax = istep;
		}

	for (i = 1; i <= data_n  ; i++ ){ 
	
		if(invert ==  1){ x[i] = data[2*i-1];  y[i] = data[2*i]; }
		if(invert == -1){ x[i] = data[2*i-1]/(data_n);  y[i] = data[2*i]/(data_n); }
	}
	
	free(data);
}

void Graph( double x[], int x1, int y1, int x2, int y2, double max, COLORREF color, char *s )
{
	int	i, ip, jp, ip2, jp2 ;
	
	PenWidth(3);  

	SetColor(WHITE); Line(x1, y1, x2, y1); Line(x1, y1, x1, y2);

	SetColor(color); FontSize(20); DrawString(x1+10, y2, s );
	
	for(i=1; i<=255; i++){
	
		ip = x1 + i ;  ip2 = x1 + (i+1) ;

		jp  = y1 - (int)(x[i]*100./max);  jp2 = y1 - (int)(x[i+1]*100./max);  

		Line( ip, jp, ip2, jp2 );
	}	
	PenWidth(1); 
}


void Main(void)
{
	char	yn, f[100];
	int		i, j, f0 , ip, jp, ip2, jp2;  
	double	sum, max;
   	double	g[257], G[257], Gr[257], Gi[257], H[257], GHr[257], GHi[257], GH[257];

	FILE *fp;
	
	TextWindow(10,10,350,800); Title("Convolution of Ramp Filter with FFT ");
	GraphicWindow(980,850,BK_BLACK);	
	
 START: printf("\n Ramp filter Convolution in Freq. space \n"); ClearWindow();
	

//------------ Generate sample data g[] :  Half Circle -------------- 

	for ( i= 1 ; i<= 77; i++){ g[i] = 0.0; }

	for ( i=78 ; i<=178; i++){  
	
		g[i] = sqrt(abs(50.0*50.0-((double)i-128)*((double)i-128)));
	}
	
	for ( i= 179; i<= 256; i++){ g[i] = 0.0; }	

//------------------ Integrate g[] ---------------------------- 

	for ( sum=0.0, i= 1 ; i<= 256; i++){ sum += g[i]; }

	printf("\n Integration of g = %.4lf ", sum);
	
//------------------ Display curve g[] ----------------
	
	Graph( g, 10, 100, 280, 10, 100.0, YELLOW, "Sample data (g)" );

//------------------ Transform g[] to Frequency space G[] -----------------------
		
	printf("\n\n Transform g to Frequency space "); scanf("%c",&yn);
	
	for(i=1; i<=256; i++){ Gr[i] = g[i];  Gi[i] = 0.0; }
		
	FFT1D( Gr, Gi, 256, 1);

//------------------ Display Frequency space Gr[] --------------------------

	for ( max=0.0, i= 1 ; i<= 256; i++){ if( Gr[i] > max ) max = Gr[i]; }
	
	printf("\n\n Maxcount of Freq.space G real \n = %.4lf ", max );

	printf("\n\nDisplay Frequency space G real ");scanf("%c",&yn);

	Graph( Gr, 10, 300, 280, 150, max, SKYBLUE, "Frequency space real data (Gr)" );
		
//------------------ Display Frequency space Gi[] --------------------------

	for ( max=0.0, i= 1 ; i<= 256; i++){ if( Gi[i] > max ) max = Gi[i]; }
	
	printf("\n\n Maxcount of Freq.space G image \n = %.4lf ", max );

	printf("\n\nDisplay Frequency space G image ");scanf("%c",&yn);

	Graph( Gi, 10, 550, 280, 400, max, SKYBLUE, "Frequency space image data (Gi)" );

//------------------ Display Power spectrum G --------------------------

	for ( i= 1 ; i<= 256; i++){ G[i] = sqrt( Gr[i]*Gr[i] + Gi[i]*Gi[i] ); }

	for ( max=0.0, i= 1 ; i<= 256; i++){ if( G[i] > max ) max = G[i]; }
	
	printf("\n\n Maxcount of Power spectrum of G \n = %.4lf ", max );

	printf("\n\nDisplay Power spectrum G ");scanf("%c",&yn);

	Graph( G, 10, 820, 280, 670, max, PURPLE, "Power spectrum of data g (G)" );

//----------------- Load Frequency space Ramp filter H[] ---------------------

	printf("\n\n Load Frequency space Ramp filter "); scanf("%c",&yn);
	 
	GetFileName( f, 0);  fp = fopen( f, "rt");

	for(i=1; i<=256; i++){ fscanf( fp, "%lf \n", H + i ); }

    fclose(fp);
	
//------------------ Display Frequency space Ramp filter H[] ------------------

	printf("\n\nDisplay Frequency space Ramp filter ");scanf("%c",&yn);

	Graph( H, 350, 200, 630, 10, 100.0, RED, "Frequency space Ramp filter (H)" );

//------------------ Convolution H[] into G[] ---------------------------- 

	for ( i= 1 ; i<= 256; i++ ){ GHr[i] = Gr[i] * H[i] ; }

	for ( i= 1 ; i<= 256; i++ ){ GHi[i] = Gi[i] * H[i] ; }

//------------------ Display Convolved GH real ---------------------------

	printf("\n\nDisplay Frequency space Convolved GH real");scanf("%c",&yn);

	for ( max=0.0, i= 1 ; i<= 256; i++){ if( GHr[i] > max ) max = GHr[i]; }
	
	Graph( GHr, 350, 450, 630, 300, max, SKYBLUE, "Convolution in frequency space (Gr x H)" );

//------------------ Display Convolved Power spectrum GH ------------------

	printf("\n\nDisplay Power spectrum of Convolved GH ");scanf("%c",&yn);

	for ( i= 1 ; i<= 256; i++){ GH[i] = sqrt( GHr[i]*GHr[i] + GHi[i]*GHi[i] ); }

	for ( max=0.0, i= 1 ; i<= 256; i++){ if( GH[i] > max ) max = GH[i]; }
	
	Graph( GH, 350, 820, 630, 670, max, PURPLE, "Convolution of Power spectrum (G x H)" );
	
//------------------- Transform convolved GH into real space -------------

	FFT1D( GHr, GHi, 256, -1 );

//------------------- Display Convolved g --------------------------------

	printf("\n\nDisplay Convolved g with FFT ");scanf("%c",&yn);

	Graph( GHr, 700, 200, 960, 10, 100.0, GREEN, "IFFT  of  G x H" );

//----------------- Integration of Convolved g -------------
    
	for(sum=0.0, i=1; i<=256; i++ ){ sum += GHr[i]; }

	printf("\n\n Integration of Convolved g with FFT \n = %.4lf ", sum);

//------------------- End -------------------------------
	
	printf("\n\n Retry? (no:n) ");scanf("%c",&yn);
	if(yn!='n')goto START;
	exit(0);
}
